# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import StrictStr
from ephor_ai_test_sdk.models.create_feedback_request import CreateFeedbackRequest
from ephor_ai_test_sdk.models.feedback_response import FeedbackResponse

from ephor_ai_test_sdk.api_client import ApiClient, RequestSerialized
from ephor_ai_test_sdk.api_response import ApiResponse
from ephor_ai_test_sdk.rest import RESTResponseType


class FeedbackApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def create_feedback_api_v1_feedback_post(
        self,
        create_feedback_request: CreateFeedbackRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> FeedbackResponse:
        """Create Feedback

        Create a new feedback entry for an AI message.  Args:     feedback (CreateFeedbackRequest): The feedback data including message references and feedback details     auth (EndpointAuth): The authenticated endpoint information  Returns:     FeedbackResponse: The created feedback entry  Raises:     HTTPException: If there's an error creating the feedback

        :param create_feedback_request: (required)
        :type create_feedback_request: CreateFeedbackRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_feedback_api_v1_feedback_post_serialize(
            create_feedback_request=create_feedback_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def create_feedback_api_v1_feedback_post_with_http_info(
        self,
        create_feedback_request: CreateFeedbackRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[FeedbackResponse]:
        """Create Feedback

        Create a new feedback entry for an AI message.  Args:     feedback (CreateFeedbackRequest): The feedback data including message references and feedback details     auth (EndpointAuth): The authenticated endpoint information  Returns:     FeedbackResponse: The created feedback entry  Raises:     HTTPException: If there's an error creating the feedback

        :param create_feedback_request: (required)
        :type create_feedback_request: CreateFeedbackRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_feedback_api_v1_feedback_post_serialize(
            create_feedback_request=create_feedback_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def create_feedback_api_v1_feedback_post_without_preload_content(
        self,
        create_feedback_request: CreateFeedbackRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Create Feedback

        Create a new feedback entry for an AI message.  Args:     feedback (CreateFeedbackRequest): The feedback data including message references and feedback details     auth (EndpointAuth): The authenticated endpoint information  Returns:     FeedbackResponse: The created feedback entry  Raises:     HTTPException: If there's an error creating the feedback

        :param create_feedback_request: (required)
        :type create_feedback_request: CreateFeedbackRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._create_feedback_api_v1_feedback_post_serialize(
            create_feedback_request=create_feedback_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _create_feedback_api_v1_feedback_post_serialize(
        self,
        create_feedback_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if create_feedback_request is not None:
            _body_params = create_feedback_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/feedback/',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def delete_feedback_api_v1_feedback_feedback_id_delete(
        self,
        feedback_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> None:
        """Delete Feedback

        Delete a feedback entry.  Args:     feedback_id (str): The ID of the feedback to delete     auth (EndpointAuth): The authenticated endpoint information  Raises:     HTTPException: If there's an error deleting the feedback

        :param feedback_id: (required)
        :type feedback_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_feedback_api_v1_feedback_feedback_id_delete_serialize(
            feedback_id=feedback_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def delete_feedback_api_v1_feedback_feedback_id_delete_with_http_info(
        self,
        feedback_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[None]:
        """Delete Feedback

        Delete a feedback entry.  Args:     feedback_id (str): The ID of the feedback to delete     auth (EndpointAuth): The authenticated endpoint information  Raises:     HTTPException: If there's an error deleting the feedback

        :param feedback_id: (required)
        :type feedback_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_feedback_api_v1_feedback_feedback_id_delete_serialize(
            feedback_id=feedback_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def delete_feedback_api_v1_feedback_feedback_id_delete_without_preload_content(
        self,
        feedback_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Delete Feedback

        Delete a feedback entry.  Args:     feedback_id (str): The ID of the feedback to delete     auth (EndpointAuth): The authenticated endpoint information  Raises:     HTTPException: If there's an error deleting the feedback

        :param feedback_id: (required)
        :type feedback_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._delete_feedback_api_v1_feedback_feedback_id_delete_serialize(
            feedback_id=feedback_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '204': None,
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _delete_feedback_api_v1_feedback_feedback_id_delete_serialize(
        self,
        feedback_id,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if feedback_id is not None:
            _path_params['feedback_id'] = feedback_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='DELETE',
            resource_path='/api/v1/feedback/{feedback_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def get_message_feedback_api_v1_feedback_message_id_get(
        self,
        message_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> FeedbackResponse:
        """Get Message Feedback

        Get feedback for a specific message.  Args:     message_id (str): The ID of the message to get feedback for     auth (EndpointAuth): The authenticated endpoint information  Returns:     Optional[FeedbackResponse]: The feedback entry if it exists  Raises:     HTTPException: If there's an error retrieving the feedback

        :param message_id: (required)
        :type message_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_message_feedback_api_v1_feedback_message_id_get_serialize(
            message_id=message_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_message_feedback_api_v1_feedback_message_id_get_with_http_info(
        self,
        message_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[FeedbackResponse]:
        """Get Message Feedback

        Get feedback for a specific message.  Args:     message_id (str): The ID of the message to get feedback for     auth (EndpointAuth): The authenticated endpoint information  Returns:     Optional[FeedbackResponse]: The feedback entry if it exists  Raises:     HTTPException: If there's an error retrieving the feedback

        :param message_id: (required)
        :type message_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_message_feedback_api_v1_feedback_message_id_get_serialize(
            message_id=message_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_message_feedback_api_v1_feedback_message_id_get_without_preload_content(
        self,
        message_id: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Get Message Feedback

        Get feedback for a specific message.  Args:     message_id (str): The ID of the message to get feedback for     auth (EndpointAuth): The authenticated endpoint information  Returns:     Optional[FeedbackResponse]: The feedback entry if it exists  Raises:     HTTPException: If there's an error retrieving the feedback

        :param message_id: (required)
        :type message_id: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_message_feedback_api_v1_feedback_message_id_get_serialize(
            message_id=message_id,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "FeedbackResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _get_message_feedback_api_v1_feedback_message_id_get_serialize(
        self,
        message_id,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if message_id is not None:
            _path_params['message_id'] = message_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/api/v1/feedback/{message_id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


