# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import StrictStr
from typing import Any
from ephor_ai_test_sdk.models.ingest_local_file_request import IngestLocalFileRequest
from ephor_ai_test_sdk.models.ingest_request import IngestRequest
from ephor_ai_test_sdk.models.ingest_response import IngestResponse
from ephor_ai_test_sdk.models.ingest_stats import IngestStats
from ephor_ai_test_sdk.models.ingest_video_request import IngestVideoRequest
from ephor_ai_test_sdk.models.workflowy_refresh_request import WorkflowyRefreshRequest
from ephor_ai_test_sdk.models.workflowy_secret_link_request import WorkflowySecretLinkRequest

from ephor_ai_test_sdk.api_client import ApiClient, RequestSerialized
from ephor_ai_test_sdk.api_response import ApiResponse
from ephor_ai_test_sdk.rest import RESTResponseType


class IngestApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_indexing_stats_api_v1_library_ingest_stats_namespace_get(
        self,
        namespace: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> IngestStats:
        """Get Indexing Stats

        Get the indexing stats for a given namespace.  Args:     namespace (str): The namespace to check the stats for.  Returns:     IngestStats: A dictionary containing the stats information.  Raises:     HTTPException: If there's an error during the stats check.

        :param namespace: (required)
        :type namespace: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_indexing_stats_api_v1_library_ingest_stats_namespace_get_serialize(
            namespace=namespace,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestStats",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_indexing_stats_api_v1_library_ingest_stats_namespace_get_with_http_info(
        self,
        namespace: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[IngestStats]:
        """Get Indexing Stats

        Get the indexing stats for a given namespace.  Args:     namespace (str): The namespace to check the stats for.  Returns:     IngestStats: A dictionary containing the stats information.  Raises:     HTTPException: If there's an error during the stats check.

        :param namespace: (required)
        :type namespace: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_indexing_stats_api_v1_library_ingest_stats_namespace_get_serialize(
            namespace=namespace,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestStats",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_indexing_stats_api_v1_library_ingest_stats_namespace_get_without_preload_content(
        self,
        namespace: StrictStr,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Get Indexing Stats

        Get the indexing stats for a given namespace.  Args:     namespace (str): The namespace to check the stats for.  Returns:     IngestStats: A dictionary containing the stats information.  Raises:     HTTPException: If there's an error during the stats check.

        :param namespace: (required)
        :type namespace: str
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_indexing_stats_api_v1_library_ingest_stats_namespace_get_serialize(
            namespace=namespace,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestStats",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _get_indexing_stats_api_v1_library_ingest_stats_namespace_get_serialize(
        self,
        namespace,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if namespace is not None:
            _path_params['namespace'] = namespace
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/api/v1/library/ingest/stats/{namespace}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def ingest_documents_api_v1_library_ingest_post(
        self,
        ingest_request: IngestRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> IngestResponse:
        """Ingest Documents

        Ingest documents from a Google Drive folder.  Args:     request (IngestRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.     library_id (str): The library ID to add the ingested documents to. Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_request: (required)
        :type ingest_request: IngestRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_documents_api_v1_library_ingest_post_serialize(
            ingest_request=ingest_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def ingest_documents_api_v1_library_ingest_post_with_http_info(
        self,
        ingest_request: IngestRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[IngestResponse]:
        """Ingest Documents

        Ingest documents from a Google Drive folder.  Args:     request (IngestRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.     library_id (str): The library ID to add the ingested documents to. Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_request: (required)
        :type ingest_request: IngestRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_documents_api_v1_library_ingest_post_serialize(
            ingest_request=ingest_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def ingest_documents_api_v1_library_ingest_post_without_preload_content(
        self,
        ingest_request: IngestRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Ingest Documents

        Ingest documents from a Google Drive folder.  Args:     request (IngestRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.     library_id (str): The library ID to add the ingested documents to. Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_request: (required)
        :type ingest_request: IngestRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_documents_api_v1_library_ingest_post_serialize(
            ingest_request=ingest_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _ingest_documents_api_v1_library_ingest_post_serialize(
        self,
        ingest_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if ingest_request is not None:
            _body_params = ingest_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/library/ingest/',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def ingest_local_file_api_v1_library_ingest_local_file_post(
        self,
        ingest_local_file_request: IngestLocalFileRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> IngestResponse:
        """Ingest Local File

        Ingest a local file.  Args:     request (IngestLocalFileRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.  Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_local_file_request: (required)
        :type ingest_local_file_request: IngestLocalFileRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_local_file_api_v1_library_ingest_local_file_post_serialize(
            ingest_local_file_request=ingest_local_file_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def ingest_local_file_api_v1_library_ingest_local_file_post_with_http_info(
        self,
        ingest_local_file_request: IngestLocalFileRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[IngestResponse]:
        """Ingest Local File

        Ingest a local file.  Args:     request (IngestLocalFileRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.  Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_local_file_request: (required)
        :type ingest_local_file_request: IngestLocalFileRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_local_file_api_v1_library_ingest_local_file_post_serialize(
            ingest_local_file_request=ingest_local_file_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def ingest_local_file_api_v1_library_ingest_local_file_post_without_preload_content(
        self,
        ingest_local_file_request: IngestLocalFileRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Ingest Local File

        Ingest a local file.  Args:     request (IngestLocalFileRequest): The ingest request details.     background_tasks (BackgroundTasks): FastAPI's background tasks handler.  Returns:     IngestResponse: Response containing ingest process details.  Raises:     HTTPException: If there's an error during the ingestion process.

        :param ingest_local_file_request: (required)
        :type ingest_local_file_request: IngestLocalFileRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_local_file_api_v1_library_ingest_local_file_post_serialize(
            ingest_local_file_request=ingest_local_file_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _ingest_local_file_api_v1_library_ingest_local_file_post_serialize(
        self,
        ingest_local_file_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if ingest_local_file_request is not None:
            _body_params = ingest_local_file_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/library/ingest/local-file',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def ingest_video_api_v1_library_ingest_video_post(
        self,
        ingest_video_request: IngestVideoRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> IngestResponse:
        """Ingest Video


        :param ingest_video_request: (required)
        :type ingest_video_request: IngestVideoRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_video_api_v1_library_ingest_video_post_serialize(
            ingest_video_request=ingest_video_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def ingest_video_api_v1_library_ingest_video_post_with_http_info(
        self,
        ingest_video_request: IngestVideoRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[IngestResponse]:
        """Ingest Video


        :param ingest_video_request: (required)
        :type ingest_video_request: IngestVideoRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_video_api_v1_library_ingest_video_post_serialize(
            ingest_video_request=ingest_video_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def ingest_video_api_v1_library_ingest_video_post_without_preload_content(
        self,
        ingest_video_request: IngestVideoRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Ingest Video


        :param ingest_video_request: (required)
        :type ingest_video_request: IngestVideoRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._ingest_video_api_v1_library_ingest_video_post_serialize(
            ingest_video_request=ingest_video_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "IngestResponse",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _ingest_video_api_v1_library_ingest_video_post_serialize(
        self,
        ingest_video_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if ingest_video_request is not None:
            _body_params = ingest_video_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/library/ingest/video',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post(
        self,
        workflowy_refresh_request: WorkflowyRefreshRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> object:
        """Refresh Workflowy Nodes


        :param workflowy_refresh_request: (required)
        :type workflowy_refresh_request: WorkflowyRefreshRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_serialize(
            workflowy_refresh_request=workflowy_refresh_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_with_http_info(
        self,
        workflowy_refresh_request: WorkflowyRefreshRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[object]:
        """Refresh Workflowy Nodes


        :param workflowy_refresh_request: (required)
        :type workflowy_refresh_request: WorkflowyRefreshRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_serialize(
            workflowy_refresh_request=workflowy_refresh_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_without_preload_content(
        self,
        workflowy_refresh_request: WorkflowyRefreshRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Refresh Workflowy Nodes


        :param workflowy_refresh_request: (required)
        :type workflowy_refresh_request: WorkflowyRefreshRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_serialize(
            workflowy_refresh_request=workflowy_refresh_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _refresh_workflowy_nodes_api_v1_library_ingest_workflowy_refresh_post_serialize(
        self,
        workflowy_refresh_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if workflowy_refresh_request is not None:
            _body_params = workflowy_refresh_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/library/ingest/workflowy/refresh',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )




    @validate_call
    def scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post(
        self,
        workflowy_secret_link_request: WorkflowySecretLinkRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> object:
        """Scrape And Ingest Workflowy


        :param workflowy_secret_link_request: (required)
        :type workflowy_secret_link_request: WorkflowySecretLinkRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_serialize(
            workflowy_secret_link_request=workflowy_secret_link_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_with_http_info(
        self,
        workflowy_secret_link_request: WorkflowySecretLinkRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> ApiResponse[object]:
        """Scrape And Ingest Workflowy


        :param workflowy_secret_link_request: (required)
        :type workflowy_secret_link_request: WorkflowySecretLinkRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_serialize(
            workflowy_secret_link_request=workflowy_secret_link_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_without_preload_content(
        self,
        workflowy_secret_link_request: WorkflowySecretLinkRequest,
        request_timeout__: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        request_auth__: Optional[Dict[StrictStr, Any]] = None,
        content_type__: Optional[StrictStr] = None,
        headers__: Optional[Dict[StrictStr, Any]] = None,
        host__: Optional[StrictStr] = None,
    ) -> RESTResponseType:
        """Scrape And Ingest Workflowy


        :param workflowy_secret_link_request: (required)
        :type workflowy_secret_link_request: WorkflowySecretLinkRequest
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_serialize(
            workflowy_secret_link_request=workflowy_secret_link_request,
            request_auth__=request_auth__,
            content_type__=content_type__,
            headers__=headers__,
            host__=host__
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "object",
            '422': "HTTPValidationError",
        }
        response_data = self.api_client.call_api(
            *_param,
            request_timeout__=request_timeout__
        )
        return response_data.response


    def _scrape_and_ingest_workflowy_api_v1_library_ingest_workflowy_post_serialize(
        self,
        workflowy_secret_link_request,
        request_auth__,
        content_type__,
        headers__,
        host__,
    ) -> RequestSerialized:


        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = headers__ or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if workflowy_secret_link_request is not None:
            _body_params = workflowy_secret_link_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )

        # set the HTTP header `Content-Type`
        if content_type__:
            _header_params['Content-Type'] = content_type__
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'APIKeyHeader'
        ]

        return self.api_client.param_serialize(
            method='POST',
            resource_path='/api/v1/library/ingest/workflowy',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            host__=host__,
            request_auth__=request_auth__
        )


