# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Artifact(BaseModel):
    """
    Artifact
    """ # noqa: E501
    artifact_id: StrictStr
    template: StrictStr
    content: StrictStr
    published_url: Optional[StrictStr] = None
    artifact_name: Optional[StrictStr] = None
    extra_dependencies: Optional[Dict[str, StrictStr]] = None
    __properties: ClassVar[List[str]] = ["artifact_id", "template", "content", "published_url", "artifact_name", "extra_dependencies"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Artifact from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if published_url (nullable) is None
        # and model_fields_set contains the field
        if self.published_url is None and "published_url" in self.model_fields_set:
            _dict['published_url'] = None

        # set to None if artifact_name (nullable) is None
        # and model_fields_set contains the field
        if self.artifact_name is None and "artifact_name" in self.model_fields_set:
            _dict['artifact_name'] = None

        # set to None if extra_dependencies (nullable) is None
        # and model_fields_set contains the field
        if self.extra_dependencies is None and "extra_dependencies" in self.model_fields_set:
            _dict['extra_dependencies'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Artifact from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "artifact_id": obj.get("artifact_id"),
            "template": obj.get("template"),
            "content": obj.get("content"),
            "published_url": obj.get("published_url"),
            "artifact_name": obj.get("artifact_name"),
            "extra_dependencies": obj.get("extra_dependencies")
        })
        return _obj


