# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BodyExportDataApiV1ProjectsProjectIdExportPost(BaseModel):
    """
    BodyExportDataApiV1ProjectsProjectIdExportPost
    """ # noqa: E501
    export_option: StrictStr = Field(description="Export option: 'project' or 'channel'")
    export_type: StrictStr = Field(description="Export type: 'text', 'json', or 'xml'")
    channel_id: Optional[StrictStr] = None
    include_artifacts: Optional[StrictBool] = Field(default=False, description="Include artifacts in the export")
    include_slm_data: Optional[StrictBool] = Field(default=False, description="Include SLM data in the export")
    __properties: ClassVar[List[str]] = ["export_option", "export_type", "channel_id", "include_artifacts", "include_slm_data"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BodyExportDataApiV1ProjectsProjectIdExportPost from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if channel_id (nullable) is None
        # and model_fields_set contains the field
        if self.channel_id is None and "channel_id" in self.model_fields_set:
            _dict['channel_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BodyExportDataApiV1ProjectsProjectIdExportPost from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "export_option": obj.get("export_option"),
            "export_type": obj.get("export_type"),
            "channel_id": obj.get("channel_id"),
            "include_artifacts": obj.get("include_artifacts") if obj.get("include_artifacts") is not None else False,
            "include_slm_data": obj.get("include_slm_data") if obj.get("include_slm_data") is not None else False
        })
        return _obj


