# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ephor_ai_test_sdk.models.manifest_item import ManifestItem
from typing import Optional, Set
from typing_extensions import Self

class LibraryItem(BaseModel):
    """
    LibraryItem
    """ # noqa: E501
    index_reference: StrictStr
    name: Optional[StrictStr] = None
    manifest: List[ManifestItem]
    is_multipart: Optional[StrictBool] = False
    last_part: Optional[StrictInt] = 0
    __properties: ClassVar[List[str]] = ["index_reference", "name", "manifest", "is_multipart", "last_part"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LibraryItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in manifest (list)
        _items = []
        if self.manifest:
            for _item_manifest in self.manifest:
                if _item_manifest:
                    _items.append(_item_manifest.to_dict())
            _dict['manifest'] = _items
        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LibraryItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "index_reference": obj.get("index_reference"),
            "name": obj.get("name"),
            "manifest": [ManifestItem.from_dict(_item) for _item in obj["manifest"]] if obj.get("manifest") is not None else None,
            "is_multipart": obj.get("is_multipart") if obj.get("is_multipart") is not None else False,
            "last_part": obj.get("last_part") if obj.get("last_part") is not None else 0
        })
        return _obj


