# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ephor_ai_test_sdk.models.library_output import LibraryOutput
from typing import Optional, Set
from typing_extensions import Self

class Project(BaseModel):
    """
    Project
    """ # noqa: E501
    project_id: StrictStr
    name: StrictStr
    description: StrictStr
    collection: List[Dict[str, Any]]
    owner_id: Optional[StrictStr]
    users: Dict[str, Any]
    invite_link_id: Optional[StrictStr] = None
    invitations: Optional[Dict[str, Any]] = None
    predefined_queries: Optional[List[StrictStr]]
    custom_instructions: Optional[StrictStr]
    model: StrictStr
    comments: Optional[List[Dict[str, Any]]]
    library: LibraryOutput
    updated_at: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["project_id", "name", "description", "collection", "owner_id", "users", "invite_link_id", "invitations", "predefined_queries", "custom_instructions", "model", "comments", "library", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Project from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of library
        if self.library:
            _dict['library'] = self.library.to_dict()
        # set to None if owner_id (nullable) is None
        # and model_fields_set contains the field
        if self.owner_id is None and "owner_id" in self.model_fields_set:
            _dict['owner_id'] = None

        # set to None if invite_link_id (nullable) is None
        # and model_fields_set contains the field
        if self.invite_link_id is None and "invite_link_id" in self.model_fields_set:
            _dict['invite_link_id'] = None

        # set to None if invitations (nullable) is None
        # and model_fields_set contains the field
        if self.invitations is None and "invitations" in self.model_fields_set:
            _dict['invitations'] = None

        # set to None if predefined_queries (nullable) is None
        # and model_fields_set contains the field
        if self.predefined_queries is None and "predefined_queries" in self.model_fields_set:
            _dict['predefined_queries'] = None

        # set to None if custom_instructions (nullable) is None
        # and model_fields_set contains the field
        if self.custom_instructions is None and "custom_instructions" in self.model_fields_set:
            _dict['custom_instructions'] = None

        # set to None if comments (nullable) is None
        # and model_fields_set contains the field
        if self.comments is None and "comments" in self.model_fields_set:
            _dict['comments'] = None

        # set to None if updated_at (nullable) is None
        # and model_fields_set contains the field
        if self.updated_at is None and "updated_at" in self.model_fields_set:
            _dict['updated_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Project from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "project_id": obj.get("project_id"),
            "name": obj.get("name"),
            "description": obj.get("description"),
            "collection": obj.get("collection"),
            "owner_id": obj.get("owner_id"),
            "users": obj.get("users"),
            "invite_link_id": obj.get("invite_link_id"),
            "invitations": obj.get("invitations"),
            "predefined_queries": obj.get("predefined_queries"),
            "custom_instructions": obj.get("custom_instructions"),
            "model": obj.get("model"),
            "comments": obj.get("comments"),
            "library": LibraryOutput.from_dict(obj["library"]) if obj.get("library") is not None else None,
            "updated_at": obj.get("updated_at")
        })
        return _obj


