# coding: utf-8

"""
    Ephor.ai

    Collaborative AI

    The version of the OpenAPI document: 1.3.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from ephor_ai_test_sdk.models.transcript_message import TranscriptMessage
from typing import Optional, Set
from typing_extensions import Self

class Transcript(BaseModel):
    """
    Transcript
    """ # noqa: E501
    id: StrictStr
    account_id: StrictStr
    stage: Optional[StrictStr] = 'active'
    created_at: StrictStr
    messages: List[TranscriptMessage]
    updated_at: StrictStr
    question: Optional[StrictStr] = None
    seconds_elapsed_on_question: Optional[StrictInt] = None
    reflections: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id", "account_id", "stage", "created_at", "messages", "updated_at", "question", "seconds_elapsed_on_question", "reflections"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Transcript from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item_messages in self.messages:
                if _item_messages:
                    _items.append(_item_messages.to_dict())
            _dict['messages'] = _items
        # set to None if question (nullable) is None
        # and model_fields_set contains the field
        if self.question is None and "question" in self.model_fields_set:
            _dict['question'] = None

        # set to None if seconds_elapsed_on_question (nullable) is None
        # and model_fields_set contains the field
        if self.seconds_elapsed_on_question is None and "seconds_elapsed_on_question" in self.model_fields_set:
            _dict['seconds_elapsed_on_question'] = None

        # set to None if reflections (nullable) is None
        # and model_fields_set contains the field
        if self.reflections is None and "reflections" in self.model_fields_set:
            _dict['reflections'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Transcript from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "account_id": obj.get("account_id"),
            "stage": obj.get("stage") if obj.get("stage") is not None else 'active',
            "created_at": obj.get("created_at"),
            "messages": [TranscriptMessage.from_dict(_item) for _item in obj["messages"]] if obj.get("messages") is not None else None,
            "updated_at": obj.get("updated_at"),
            "question": obj.get("question"),
            "seconds_elapsed_on_question": obj.get("seconds_elapsed_on_question"),
            "reflections": obj.get("reflections")
        })
        return _obj


